<?php
/**
 * 订单事件触发将消息通知到prism
 *
 */
class sysaftersales_events_listeners_notifyPrism {

    /**
     * 创建退款申请消息，将消息通知到prism
     *
     * @param array $tid 退款的订单
     * @param array $data
     */
    public function refundCreated($tid, $data)
    {
        if( ! config::get('prism.prismNotify',false) ) return true;

        $notifyData['prismNotifyName'] = 'refundCreated';
        $notifyData['tid'] = $tid;

        if( $data['oid'] )//取消订单生成退款单不需要子订单号，售后退款需要指定子订单
        {
            $notifyData['oid'] = $data['oid'];
        }

        $notifyData['shop_id'] = $data['shop_id'];
        $notifyData['user_id'] = $data['user_id'];
        $notifyData['refund_bn'] = $data['refund_bn'];
        $notifyData['refunds_type'] = $data['refunds_type'];//0 售后申请退款 1 取消订单退款
        $notifyData['refund_fee'] = $data['total_price'];

        return kernel::single('system_prism_notify')->write($notifyData['shop_id'], $notifyData);
    }

    /**
     * 更新退款申请单
     */
    public function refundModified($data)
    {
        if( ! config::get('prism.prismNotify',false) ) return true;

        $notifyData['prismNotifyName'] = 'refundModified';
        $notifyData['tid'] = $data['tid'];

        if( $data['oid'] )//取消订单生成退款单不需要子订单号，售后退款需要指定子订单
        {
            $notifyData['oid'] = $data['oid'];
        }

        $notifyData['shop_id'] = $data['shop_id'];
        $notifyData['user_id'] = $data['user_id'];
        $notifyData['refund_bn'] = $data['refund_bn'];
        $notifyData['refunds_type'] = $data['refunds_type'];//0 售后申请退款 1 取消订单退款
        $notifyData['refund_fee'] = $data['total_price'];
        $notifyData['status'] = $data['status'];

        return kernel::single('system_prism_notify')->write($notifyData['shop_id'], $notifyData);
    }
}

